// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An error encountered by the Batch service when scheduling a job.
    /// </summary>
    public partial class JobSchedulingError : IPropertyMetadata
    {
        private readonly Common.SchedulingErrorCategory category;
        private readonly string code;
        private readonly IReadOnlyList<NameValuePair> details;
        private readonly string message;

        #region Constructors

        internal JobSchedulingError(Models.JobSchedulingError protocolObject)
        {
            this.category = UtilitiesInternal.MapEnum<Models.SchedulingErrorCategory, Common.SchedulingErrorCategory>(protocolObject.Category);
            this.code = protocolObject.Code;
            this.details = NameValuePair.ConvertFromProtocolCollectionReadOnly(protocolObject.Details);
            this.message = protocolObject.Message;
        }

        #endregion Constructors

        #region JobSchedulingError

        /// <summary>
        /// Gets the category of the job scheduling error.
        /// </summary>
        public Common.SchedulingErrorCategory Category
        {
            get { return this.category; }
        }

        /// <summary>
        /// Gets a code for the job scheduling error. See <see cref="Common.JobSchedulingErrorCodes"/> for possible values.
        /// </summary>
        public string Code
        {
            get { return this.code; }
        }

        /// <summary>
        /// Gets a list of additional error details related to the scheduling error.
        /// </summary>
        public IReadOnlyList<NameValuePair> Details
        {
            get { return this.details; }
        }

        /// <summary>
        /// Gets a message describing the job scheduling error, intended to be suitable for display in a user interface.
        /// </summary>
        public string Message
        {
            get { return this.message; }
        }

        #endregion // JobSchedulingError

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata
    }
}