// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// An error encountered by the Batch service when deleting a certificate.
    /// </summary>
    public partial class DeleteCertificateError
    {
        /// <summary>
        /// Initializes a new instance of the DeleteCertificateError class.
        /// </summary>
        public DeleteCertificateError() { }

        /// <summary>
        /// Initializes a new instance of the DeleteCertificateError class.
        /// </summary>
        /// <param name="code">An identifier for the certificate deletion
        /// error. Codes are invariant and are intended to be consumed
        /// programmatically.</param>
        /// <param name="message">A message describing the certificate
        /// deletion error, intended to be suitable for display in a user
        /// interface.</param>
        /// <param name="values">A list of additional error details related to
        /// the certificate deletion error.</param>
        public DeleteCertificateError(string code = default(string), string message = default(string), System.Collections.Generic.IList<NameValuePair> values = default(System.Collections.Generic.IList<NameValuePair>))
        {
            Code = code;
            Message = message;
            Values = values;
        }

        /// <summary>
        /// Gets or sets an identifier for the certificate deletion error.
        /// Codes are invariant and are intended to be consumed
        /// programmatically.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets a message describing the certificate deletion error,
        /// intended to be suitable for display in a user interface.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets a list of additional error details related to the
        /// certificate deletion error.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "values")]
        public System.Collections.Generic.IList<NameValuePair> Values { get; set; }

    }
}
