// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// Specifies any dependencies of a task. Any task that is explicitly
    /// specified or within a dependency range must complete before the
    /// dependant task will be scheduled.
    /// </summary>
    public partial class TaskDependencies
    {
        /// <summary>
        /// Initializes a new instance of the TaskDependencies class.
        /// </summary>
        public TaskDependencies() { }

        /// <summary>
        /// Initializes a new instance of the TaskDependencies class.
        /// </summary>
        /// <param name="taskIds">The list of task ids that must complete
        /// before this task can be scheduled.</param>
        /// <param name="taskIdRanges">The list of task ranges that must
        /// complete before this task can be scheduled.</param>
        public TaskDependencies(System.Collections.Generic.IList<string> taskIds = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<TaskIdRange> taskIdRanges = default(System.Collections.Generic.IList<TaskIdRange>))
        {
            TaskIds = taskIds;
            TaskIdRanges = taskIdRanges;
        }

        /// <summary>
        /// Gets or sets the list of task ids that must complete before this
        /// task can be scheduled.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "taskIds")]
        public System.Collections.Generic.IList<string> TaskIds { get; set; }

        /// <summary>
        /// Gets or sets the list of task ranges that must complete before
        /// this task can be scheduled.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "taskIdRanges")]
        public System.Collections.Generic.IList<TaskIdRange> TaskIdRanges { get; set; }

    }
}
