// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// Parameters for a CloudTaskOperations.Update request.
    /// </summary>
    public partial class TaskUpdateParameter
    {
        /// <summary>
        /// Initializes a new instance of the TaskUpdateParameter class.
        /// </summary>
        public TaskUpdateParameter() { }

        /// <summary>
        /// Initializes a new instance of the TaskUpdateParameter class.
        /// </summary>
        /// <param name="constraints">Constraints that apply to this
        /// task.</param>
        public TaskUpdateParameter(TaskConstraints constraints = default(TaskConstraints))
        {
            Constraints = constraints;
        }

        /// <summary>
        /// Gets or sets constraints that apply to this task.
        /// </summary>
        /// <remarks>
        /// If omitted, the task is given the default constraints.
        /// </remarks>
        [Newtonsoft.Json.JsonProperty(PropertyName = "constraints")]
        public TaskConstraints Constraints { get; set; }

    }
}
