// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.KeyVault.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Details of the organization of the certificate issuer.
    /// </summary>
    public partial class OrganizationDetails
    {
        /// <summary>
        /// Initializes a new instance of the OrganizationDetails class.
        /// </summary>
        public OrganizationDetails() { }

        /// <summary>
        /// Initializes a new instance of the OrganizationDetails class.
        /// </summary>
        /// <param name="id">Id of the organization.</param>
        /// <param name="adminDetails">Details of the organization
        /// administrator.</param>
        public OrganizationDetails(string id = default(string), IList<AdministratorDetails> adminDetails = default(IList<AdministratorDetails>))
        {
            Id = id;
            AdminDetails = adminDetails;
        }

        /// <summary>
        /// Gets or sets id of the organization.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets details of the organization administrator.
        /// </summary>
        [JsonProperty(PropertyName = "admin_details")]
        public IList<AdministratorDetails> AdminDetails { get; set; }

    }
}
