// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Automation;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation
{
    public static partial class AgentRegistrationOperationExtensions
    {
        /// <summary>
        /// Retrieve the automation agent registration information.  (see
        /// http://aka.ms/azureautomationsdk/agentregistrationoperations for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Automation.IAgentRegistrationOperation.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// Required. The automation account name.
        /// </param>
        /// <returns>
        /// The response model for the get agent registration information
        /// operation.
        /// </returns>
        public static AgentRegistrationGetResponse Get(this IAgentRegistrationOperation operations, string resourceGroupName, string automationAccount)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAgentRegistrationOperation)s).GetAsync(resourceGroupName, automationAccount);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Retrieve the automation agent registration information.  (see
        /// http://aka.ms/azureautomationsdk/agentregistrationoperations for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Automation.IAgentRegistrationOperation.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// Required. The automation account name.
        /// </param>
        /// <returns>
        /// The response model for the get agent registration information
        /// operation.
        /// </returns>
        public static Task<AgentRegistrationGetResponse> GetAsync(this IAgentRegistrationOperation operations, string resourceGroupName, string automationAccount)
        {
            return operations.GetAsync(resourceGroupName, automationAccount, CancellationToken.None);
        }
        
        /// <summary>
        /// Regenerate a primary or secondary agent registration key  (see
        /// http://aka.ms/azureautomationsdk/agentregistrationoperations for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Automation.IAgentRegistrationOperation.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// Required. The automation account name.
        /// </param>
        /// <param name='keyName'>
        /// Required. The name of the agent registration key to be regenerated
        /// </param>
        /// <returns>
        /// The response model for the agent registration key regenerate
        /// operation.
        /// </returns>
        public static AgentRegistrationRegenerateKeyResponse RegenerateKey(this IAgentRegistrationOperation operations, string resourceGroupName, string automationAccount, AgentRegistrationRegenerateKeyParameter keyName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAgentRegistrationOperation)s).RegenerateKeyAsync(resourceGroupName, automationAccount, keyName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Regenerate a primary or secondary agent registration key  (see
        /// http://aka.ms/azureautomationsdk/agentregistrationoperations for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Automation.IAgentRegistrationOperation.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// Required. The automation account name.
        /// </param>
        /// <param name='keyName'>
        /// Required. The name of the agent registration key to be regenerated
        /// </param>
        /// <returns>
        /// The response model for the agent registration key regenerate
        /// operation.
        /// </returns>
        public static Task<AgentRegistrationRegenerateKeyResponse> RegenerateKeyAsync(this IAgentRegistrationOperation operations, string resourceGroupName, string automationAccount, AgentRegistrationRegenerateKeyParameter keyName)
        {
            return operations.RegenerateKeyAsync(resourceGroupName, automationAccount, keyName, CancellationToken.None);
        }
    }
}
