// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The reference information for an Azure Marketplace image.
    /// </summary>
    public partial class GalleryImageReference
    {
        /// <summary>
        /// Initializes a new instance of the GalleryImageReference class.
        /// </summary>
        public GalleryImageReference() { }

        /// <summary>
        /// Initializes a new instance of the GalleryImageReference class.
        /// </summary>
        public GalleryImageReference(string offer = default(string), string publisher = default(string), string sku = default(string), string osType = default(string), string version = default(string))
        {
            Offer = offer;
            Publisher = publisher;
            Sku = sku;
            OsType = osType;
            Version = version;
        }

        /// <summary>
        /// The offer of the gallery image.
        /// </summary>
        [JsonProperty(PropertyName = "offer")]
        public string Offer { get; set; }

        /// <summary>
        /// The publisher of the gallery image.
        /// </summary>
        [JsonProperty(PropertyName = "publisher")]
        public string Publisher { get; set; }

        /// <summary>
        /// The SKU of the gallery image.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public string Sku { get; set; }

        /// <summary>
        /// The OS type of the gallery image.
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; set; }

        /// <summary>
        /// The version of the gallery image.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
