// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties of a resource cost item.
    /// </summary>
    public partial class ResourceCostProperties
    {
        /// <summary>
        /// Initializes a new instance of the ResourceCostProperties class.
        /// </summary>
        public ResourceCostProperties() { }

        /// <summary>
        /// Initializes a new instance of the ResourceCostProperties class.
        /// </summary>
        public ResourceCostProperties(string resourcename = default(string), string resourceGroupName = default(string), double? resourceCost = default(double?), string owner = default(string), string category = default(string), bool? exists = default(bool?), string resourceType = default(string))
        {
            Resourcename = resourcename;
            ResourceGroupName = resourceGroupName;
            ResourceCost = resourceCost;
            Owner = owner;
            Category = category;
            Exists = exists;
            ResourceType = resourceType;
        }

        /// <summary>
        /// The name of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "resourcename")]
        public string Resourcename { get; set; }

        /// <summary>
        /// The name of the resource group.
        /// </summary>
        [JsonProperty(PropertyName = "resourceGroupName")]
        public string ResourceGroupName { get; set; }

        /// <summary>
        /// The cost component of the resource cost item.
        /// </summary>
        [JsonProperty(PropertyName = "resourceCost")]
        public double? ResourceCost { get; set; }

        /// <summary>
        /// The email address of the owner of the resource
        /// </summary>
        [JsonProperty(PropertyName = "owner")]
        public string Owner { get; set; }

        /// <summary>
        /// The category of the resource. For VM this will be set to its size,
        /// for storage account it will be set to standard or premium
        /// </summary>
        [JsonProperty(PropertyName = "category")]
        public string Category { get; set; }

        /// <summary>
        /// Whether the resource still exists or not
        /// </summary>
        [JsonProperty(PropertyName = "exists")]
        public bool? Exists { get; set; }

        /// <summary>
        /// The logical resource type (ex. virtualmachine, storageaccount)
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

    }
}
