// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Property overrides on a subnet of a virtual network.
    /// </summary>
    public partial class SubnetOverride
    {
        /// <summary>
        /// Initializes a new instance of the SubnetOverride class.
        /// </summary>
        public SubnetOverride() { }

        /// <summary>
        /// Initializes a new instance of the SubnetOverride class.
        /// </summary>
        public SubnetOverride(string resourceId = default(string), string labSubnetName = default(string), string useInVmCreationPermission = default(string), string usePublicIpAddressPermission = default(string))
        {
            ResourceId = resourceId;
            LabSubnetName = labSubnetName;
            UseInVmCreationPermission = useInVmCreationPermission;
            UsePublicIpAddressPermission = usePublicIpAddressPermission;
        }

        /// <summary>
        /// The resource identifier of the subnet.
        /// </summary>
        [JsonProperty(PropertyName = "resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// The name given to the subnet within the lab.
        /// </summary>
        [JsonProperty(PropertyName = "labSubnetName")]
        public string LabSubnetName { get; set; }

        /// <summary>
        /// Indicates whether this subnet can be used during virtual machine
        /// creation. Possible values include: 'Default', 'Deny', 'Allow'
        /// </summary>
        [JsonProperty(PropertyName = "useInVmCreationPermission")]
        public string UseInVmCreationPermission { get; set; }

        /// <summary>
        /// Indicates whether public IP addresses can be assigned to virtual
        /// machines on this subnet. Possible values include: 'Default',
        /// 'Deny', 'Allow'
        /// </summary>
        [JsonProperty(PropertyName = "usePublicIpAddressPermission")]
        public string UsePublicIpAddressPermission { get; set; }

    }
}
