// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Graph.RBAC.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Contains the password profile associated with a user.
    /// </summary>
    public partial class PasswordProfile
    {
        /// <summary>
        /// Initializes a new instance of the PasswordProfile class.
        /// </summary>
        public PasswordProfile() { }

        /// <summary>
        /// Initializes a new instance of the PasswordProfile class.
        /// </summary>
        /// <param name="password">Password</param>
        /// <param name="forceChangePasswordNextLogin">Force change password on next login</param>
        public PasswordProfile(string password, bool? forceChangePasswordNextLogin = default(bool?))
        {
            Password = password;
            ForceChangePasswordNextLogin = forceChangePasswordNextLogin;
        }

        /// <summary>
        /// Gets or sets password
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; set; }

        /// <summary>
        /// Gets or sets force change password on next login
        /// </summary>
        [JsonProperty(PropertyName = "forceChangePasswordNextLogin")]
        public bool? ForceChangePasswordNextLogin { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Password == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Password");
            }
        }
    }
}
