// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// A management event aggregation condition.
    /// </summary>
    public partial class ManagementEventAggregationCondition
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ManagementEventAggregationCondition class.
        /// </summary>
        public ManagementEventAggregationCondition() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ManagementEventAggregationCondition class.
        /// </summary>
        /// <param name="operatorProperty">the condition operator. Possible
        /// values include: 'GreaterThan', 'GreaterThanOrEqual', 'LessThan',
        /// 'LessThanOrEqual'</param>
        /// <param name="threshold">the condition threshold.</param>
        /// <param name="windowSize">the period of time (in ISO 8601 duration
        /// format) that is used to monitor alert activity based on the
        /// threshold. If specified then it must be between 5 minutes and 1
        /// day.</param>
        public ManagementEventAggregationCondition(ConditionOperator? operatorProperty = default(ConditionOperator?), double? threshold = default(double?), System.TimeSpan? windowSize = default(System.TimeSpan?))
        {
            OperatorProperty = operatorProperty;
            Threshold = threshold;
            WindowSize = windowSize;
        }

        /// <summary>
        /// Gets or sets the condition operator. Possible values include:
        /// 'GreaterThan', 'GreaterThanOrEqual', 'LessThan', 'LessThanOrEqual'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "operator")]
        public ConditionOperator? OperatorProperty { get; set; }

        /// <summary>
        /// Gets or sets the condition threshold.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "threshold")]
        public double? Threshold { get; set; }

        /// <summary>
        /// Gets or sets the period of time (in ISO 8601 duration format) that
        /// is used to monitor alert activity based on the threshold. If
        /// specified then it must be between 5 minutes and 1 day.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "windowSize")]
        public System.TimeSpan? WindowSize { get; set; }

    }
}
