// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties of the provisioned event hub used by the Iot Hub.
    /// </summary>
    public partial class EventHubProperties
    {
        /// <summary>
        /// Initializes a new instance of the EventHubProperties class.
        /// </summary>
        public EventHubProperties() { }

        /// <summary>
        /// Initializes a new instance of the EventHubProperties class.
        /// </summary>
        public EventHubProperties(long? retentionTimeInDays = default(long?), int? partitionCount = default(int?), IList<string> partitionIds = default(IList<string>), string path = default(string), string endpoint = default(string), IList<SharedAccessAuthorizationRule> internalAuthorizationPolicies = default(IList<SharedAccessAuthorizationRule>), IList<SharedAccessAuthorizationRule> authorizationPolicies = default(IList<SharedAccessAuthorizationRule>))
        {
            RetentionTimeInDays = retentionTimeInDays;
            PartitionCount = partitionCount;
            PartitionIds = partitionIds;
            Path = path;
            Endpoint = endpoint;
            InternalAuthorizationPolicies = internalAuthorizationPolicies;
            AuthorizationPolicies = authorizationPolicies;
        }

        /// <summary>
        /// The retention time in days. Range of values [For F1: 1-1, S1: 1-7,
        /// S2: 1-7, S3: 1-7].
        /// </summary>
        [JsonProperty(PropertyName = "retentionTimeInDays")]
        public long? RetentionTimeInDays { get; set; }

        /// <summary>
        /// The partition count. Range of values [For F1: 2-2, S1: 2-128, S2:
        /// 2-128, S3: 2-128].
        /// </summary>
        [JsonProperty(PropertyName = "partitionCount")]
        public int? PartitionCount { get; set; }

        /// <summary>
        /// The partition ids.
        /// </summary>
        [JsonProperty(PropertyName = "partitionIds")]
        public IList<string> PartitionIds { get; set; }

        /// <summary>
        /// The eventhub path.
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// The endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "endpoint")]
        public string Endpoint { get; set; }

        /// <summary>
        /// The internal authorization rules.
        /// </summary>
        [JsonProperty(PropertyName = "internalAuthorizationPolicies")]
        public IList<SharedAccessAuthorizationRule> InternalAuthorizationPolicies { get; set; }

        /// <summary>
        /// The authorization rules.
        /// </summary>
        [JsonProperty(PropertyName = "authorizationPolicies")]
        public IList<SharedAccessAuthorizationRule> AuthorizationPolicies { get; set; }

    }
}
