// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties indicating whether a given iothub name is available.
    /// </summary>
    public partial class IotHubNameAvailabilityInfo
    {
        /// <summary>
        /// Initializes a new instance of the IotHubNameAvailabilityInfo class.
        /// </summary>
        public IotHubNameAvailabilityInfo() { }

        /// <summary>
        /// Initializes a new instance of the IotHubNameAvailabilityInfo class.
        /// </summary>
        public IotHubNameAvailabilityInfo(bool? nameAvailable = default(bool?), IotHubNameUnavailabilityReason? reason = default(IotHubNameUnavailabilityReason?), string message = default(string))
        {
            NameAvailable = nameAvailable;
            Reason = reason;
            Message = message;
        }

        /// <summary>
        /// The value which indicates whether the provided name is available.
        /// </summary>
        [JsonProperty(PropertyName = "nameAvailable")]
        public bool? NameAvailable { get; set; }

        /// <summary>
        /// The reason for unavailability. Possible values include: 'Invalid',
        /// 'AlreadyExists'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public IotHubNameUnavailabilityReason? Reason { get; set; }

        /// <summary>
        /// The message describing the detailed reason.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

    }
}
