// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class AgreementContent
    {
        /// <summary>
        /// Initializes a new instance of the AgreementContent class.
        /// </summary>
        public AgreementContent() { }

        /// <summary>
        /// Initializes a new instance of the AgreementContent class.
        /// </summary>
        public AgreementContent(AS2AgreementContent aS2 = default(AS2AgreementContent), X12AgreementContent x12 = default(X12AgreementContent), EdifactAgreementContent edifact = default(EdifactAgreementContent))
        {
            AS2 = aS2;
            X12 = x12;
            Edifact = edifact;
        }

        /// <summary>
        /// Gets or sets the AS2 agreement content.
        /// </summary>
        [JsonProperty(PropertyName = "AS2")]
        public AS2AgreementContent AS2 { get; set; }

        /// <summary>
        /// Gets or sets the X12 agreement content.
        /// </summary>
        [JsonProperty(PropertyName = "X12")]
        public X12AgreementContent X12 { get; set; }

        /// <summary>
        /// Gets or sets the EDIFACT agreement content.
        /// </summary>
        [JsonProperty(PropertyName = "Edifact")]
        public EdifactAgreementContent Edifact { get; set; }

    }
}
