// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    [JsonTransformation]
    public partial class IntegrationAccountAgreement : IntegrationAccountResource
    {
        /// <summary>
        /// Initializes a new instance of the IntegrationAccountAgreement
        /// class.
        /// </summary>
        public IntegrationAccountAgreement() { }

        /// <summary>
        /// Initializes a new instance of the IntegrationAccountAgreement
        /// class.
        /// </summary>
        public IntegrationAccountAgreement(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), DateTime? createdTime = default(DateTime?), DateTime? changedTime = default(DateTime?), object metadata = default(object), AgreementType? agreementType = default(AgreementType?), string hostPartner = default(string), string guestPartner = default(string), BusinessIdentity hostIdentity = default(BusinessIdentity), BusinessIdentity guestIdentity = default(BusinessIdentity), AgreementContent content = default(AgreementContent))
            : base(id, name, type, location, tags)
        {
            CreatedTime = createdTime;
            ChangedTime = changedTime;
            Metadata = metadata;
            AgreementType = agreementType;
            HostPartner = hostPartner;
            GuestPartner = guestPartner;
            HostIdentity = hostIdentity;
            GuestIdentity = guestIdentity;
            Content = content;
        }

        /// <summary>
        /// Gets the created time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdTime")]
        public DateTime? CreatedTime { get; private set; }

        /// <summary>
        /// Gets the changed time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.changedTime")]
        public DateTime? ChangedTime { get; private set; }

        /// <summary>
        /// Gets or sets the metadata.
        /// </summary>
        [JsonProperty(PropertyName = "properties.metadata")]
        public object Metadata { get; set; }

        /// <summary>
        /// Gets or sets the agreement type. Possible values include:
        /// 'NotSpecified', 'AS2', 'X12', 'Edifact'
        /// </summary>
        [JsonProperty(PropertyName = "properties.agreementType")]
        public AgreementType? AgreementType { get; set; }

        /// <summary>
        /// Gets or sets the host partner.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hostPartner")]
        public string HostPartner { get; set; }

        /// <summary>
        /// Gets or sets the guest partner.
        /// </summary>
        [JsonProperty(PropertyName = "properties.guestPartner")]
        public string GuestPartner { get; set; }

        /// <summary>
        /// Gets or sets the host identity.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hostIdentity")]
        public BusinessIdentity HostIdentity { get; set; }

        /// <summary>
        /// Gets or sets the guest identity.
        /// </summary>
        [JsonProperty(PropertyName = "properties.guestIdentity")]
        public BusinessIdentity GuestIdentity { get; set; }

        /// <summary>
        /// Gets or sets the agreement content.
        /// </summary>
        [JsonProperty(PropertyName = "properties.content")]
        public AgreementContent Content { get; set; }

    }
}
