// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Http logs to azure blob storage configuration
    /// </summary>
    public partial class AzureBlobStorageHttpLogsConfig
    {
        /// <summary>
        /// Initializes a new instance of the AzureBlobStorageHttpLogsConfig
        /// class.
        /// </summary>
        public AzureBlobStorageHttpLogsConfig() { }

        /// <summary>
        /// Initializes a new instance of the AzureBlobStorageHttpLogsConfig
        /// class.
        /// </summary>
        public AzureBlobStorageHttpLogsConfig(string sasUrl = default(string), int? retentionInDays = default(int?), bool? enabled = default(bool?))
        {
            SasUrl = sasUrl;
            RetentionInDays = retentionInDays;
            Enabled = enabled;
        }

        /// <summary>
        /// SAS url to a azure blob container with read/write/list/delete
        /// permissions
        /// </summary>
        [JsonProperty(PropertyName = "sasUrl")]
        public string SasUrl { get; set; }

        /// <summary>
        /// Retention in days.
        /// Remove blobs older than X days.
        /// 0 or lower means no retention.
        /// </summary>
        [JsonProperty(PropertyName = "retentionInDays")]
        public int? RetentionInDays { get; set; }

        /// <summary>
        /// Enabled
        /// </summary>
        [JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

    }
}
