// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Http logs to file system configuration
    /// </summary>
    public partial class FileSystemHttpLogsConfig
    {
        /// <summary>
        /// Initializes a new instance of the FileSystemHttpLogsConfig class.
        /// </summary>
        public FileSystemHttpLogsConfig() { }

        /// <summary>
        /// Initializes a new instance of the FileSystemHttpLogsConfig class.
        /// </summary>
        public FileSystemHttpLogsConfig(int? retentionInMb = default(int?), int? retentionInDays = default(int?), bool? enabled = default(bool?))
        {
            RetentionInMb = retentionInMb;
            RetentionInDays = retentionInDays;
            Enabled = enabled;
        }

        /// <summary>
        /// Maximum size in megabytes that http log files can use.
        /// When reached old log files will be removed to make
        /// space for new ones.
        /// Value can range between 25 and 100.
        /// </summary>
        [JsonProperty(PropertyName = "retentionInMb")]
        public int? RetentionInMb { get; set; }

        /// <summary>
        /// Retention in days.
        /// Remove files older than X days.
        /// 0 or lower means no retention.
        /// </summary>
        [JsonProperty(PropertyName = "retentionInDays")]
        public int? RetentionInDays { get; set; }

        /// <summary>
        /// Enabled
        /// </summary>
        [JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

    }
}
