// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// </summary>
    public partial class PremierAddOnRequest
    {
        /// <summary>
        /// Initializes a new instance of the PremierAddOnRequest class.
        /// </summary>
        public PremierAddOnRequest() { }

        /// <summary>
        /// Initializes a new instance of the PremierAddOnRequest class.
        /// </summary>
        public PremierAddOnRequest(string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), ArmPlan plan = default(ArmPlan), object properties = default(object), SkuDescription sku = default(SkuDescription))
        {
            Location = location;
            Tags = tags;
            Plan = plan;
            Properties = properties;
            Sku = sku;
        }

        /// <summary>
        /// Geo region resource belongs to e.g. SouthCentralUS, SouthEastAsia
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Tags associated with resource
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Azure resource manager plan
        /// </summary>
        [JsonProperty(PropertyName = "plan")]
        public ArmPlan Plan { get; set; }

        /// <summary>
        /// Resource specific properties
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public object Properties { get; set; }

        /// <summary>
        /// Sku description of the resource
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public SkuDescription Sku { get; set; }

    }
}
