// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Configuration of Azure web site
    /// </summary>
    public partial class SiteLogsConfig : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SiteLogsConfig class.
        /// </summary>
        public SiteLogsConfig() { }

        /// <summary>
        /// Initializes a new instance of the SiteLogsConfig class.
        /// </summary>
        public SiteLogsConfig(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), ApplicationLogsConfig applicationLogs = default(ApplicationLogsConfig), HttpLogsConfig httpLogs = default(HttpLogsConfig), EnabledConfig failedRequestsTracing = default(EnabledConfig), EnabledConfig detailedErrorMessages = default(EnabledConfig))
            : base(location, id, name, type, tags)
        {
            ApplicationLogs = applicationLogs;
            HttpLogs = httpLogs;
            FailedRequestsTracing = failedRequestsTracing;
            DetailedErrorMessages = detailedErrorMessages;
        }

        /// <summary>
        /// Application logs configuration
        /// </summary>
        [JsonProperty(PropertyName = "properties.applicationLogs")]
        public ApplicationLogsConfig ApplicationLogs { get; set; }

        /// <summary>
        /// Http logs configuration
        /// </summary>
        [JsonProperty(PropertyName = "properties.httpLogs")]
        public HttpLogsConfig HttpLogs { get; set; }

        /// <summary>
        /// Failed requests tracing configuration
        /// </summary>
        [JsonProperty(PropertyName = "properties.failedRequestsTracing")]
        public EnabledConfig FailedRequestsTracing { get; set; }

        /// <summary>
        /// Detailed error messages configuration
        /// </summary>
        [JsonProperty(PropertyName = "properties.detailedErrorMessages")]
        public EnabledConfig DetailedErrorMessages { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
