// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Describes an Azure Search service and its current state.
    /// </summary>
    public partial class SearchServiceResource
    {
        /// <summary>
        /// Initializes a new instance of the SearchServiceResource class.
        /// </summary>
        public SearchServiceResource() { }

        /// <summary>
        /// Initializes a new instance of the SearchServiceResource class.
        /// </summary>
        public SearchServiceResource(string id = default(string), string name = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), SearchServiceReadableProperties properties = default(SearchServiceReadableProperties))
        {
            Id = id;
            Name = name;
            Location = location;
            Tags = tags;
            Properties = properties;
        }

        /// <summary>
        /// Gets the resource Id of the Azure Search service.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets or sets the name of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the geographic location of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets tags to help categorize the Search service in the
        /// Azure Portal.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets properties of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public SearchServiceReadableProperties Properties { get; private set; }

    }
}
