// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Additional parameters for a set of operations.
    /// </summary>
    public partial class AccessCondition
    {
        /// <summary>
        /// Initializes a new instance of the AccessCondition class.
        /// </summary>
        public AccessCondition() { }

        /// <summary>
        /// Initializes a new instance of the AccessCondition class.
        /// </summary>
        public AccessCondition(string ifMatch = default(string), string ifNoneMatch = default(string))
        {
            IfMatch = ifMatch;
            IfNoneMatch = ifNoneMatch;
        }

        /// <summary>
        /// Gets or sets defines the If-Match condition. The operation will be
        /// performed only if the ETag on the server matches this value.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string IfMatch { get; set; }

        /// <summary>
        /// Gets or sets defines the If-None-Match condition. The operation
        /// will be performed only if the ETag on the server does not match
        /// this value.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string IfNoneMatch { get; set; }

    }
}
